#include <iostream>
using namespace std;
int main(){
int n,u,v,k=0;
cin>>n;
int x[n][n];
for(int i=0;i<n;i++){
    for(int j=0;j<n;j++){
        x[i][j]==0;
    }
}
for(int i=0;i<n-1;i++){
    cin>>u>>v;
    x[u-1][v-1]=1;
}
for(int i=0;i<n-1;i++){
    if(x[i][i+1]==1)
    k++;
}
if(k==n-1){
    if(n%2==1){
        cout<<n-2;
    }
    else cout<<n-3;
}


return 0;
}